package com.example.authapi.security.controller;

import com.example.authapi.security.dto.MessageDto;
import com.example.authapi.security.dto.TokenDto;
import com.example.authapi.users.application.dto.UserDTO;
import com.example.authapi.users.application.dto.UserNoExtraDataDTO;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.validation.Valid;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

public interface AuthInputPort {

    @PostMapping("/create")
    ResponseEntity<MessageDto> create(@Valid @RequestBody UserDTO dto) throws Exception;

    @PostMapping("/login")
    ResponseEntity<TokenDto> login(HttpServletResponse httpServletResponse, @RequestBody UserDTO dto) throws Exception;

    @GetMapping("/verificar")
    ResponseEntity<String> emailVerificado(@RequestParam(name = "clave") String token, HttpServletResponse httpServletResponse);

    @GetMapping("/logout")
    ResponseEntity<String> logOut(HttpServletResponse httpServletResponse);

    @GetMapping("/tokentouser/{token}")
    UserNoExtraDataDTO tokenToUser(@PathVariable("token") String token);
}
