package com.example.authapi.shared.valueObject;

import lombok.extern.slf4j.Slf4j;

import java.io.Serializable;
import java.util.Collections;
import java.util.List;

@Slf4j
public class I18nMessage implements Serializable {
    private String key;
    private List<Object> params;
    private String message;

    public I18nMessage(){
        log.info("I18nMessage...");
        this.key="";
        this.params= Collections.emptyList();
        log.info("...I18nMessage");
    }

    public I18nMessage(String key, List<Object> params){
        log.info("I18nMessage...");
        this.key=key;
        this.params=params;
        log.info("...I18nMessage");
    }

    public I18nMessage(String key){
        log.info("I18nMessage...");
        this.key=key;
        this.params=Collections.emptyList();
        log.info("...I18nMessage");
    }

    public I18nMessage(String key, List<Object> params, String translatedMessage){
        log.info("I18nMessage...");
        this.key = key;
        this.params = params;
        this.message = translatedMessage;
        log.info("...I18nMessage");
    }

    public String getKey() {
        log.info("...getKey...");
        return this.key;
    }

    public void setKey(String key) {
        log.info("...setKey...");
        this.key = key;
    }

    public List<Object> getParams() {
        log.info("...getParams...");
        return params;
    }

    public void setParams(List<Object> params) {
        log.info("...setParams...");
        this.params = params;
    }

    public String getMessage() {
        log.info("...getMessage...");
        return message;
    }

    public void setMessage(String message) {
        log.info("...setMessage...");
        this.message = message;
    }

    public int hashCode(){
        log.info("hashCode...");
        int result = 1;
        result = 31 * result + (this.key== null ? 0:this.key.hashCode());
        log.info("...hashCode");
        return result;
    }

    public boolean equals(Object obj){
        log.info("equals...");
        if(this == obj){
            log.info("...equals1");
            return true;
        } else if (obj == null) {
            log.info("...equals2");
            return false;
        } else if (!(obj instanceof I18nMessage)) {
            log.info("...equals3");
            return false;
        }else {
            I18nMessage other = (I18nMessage) obj;
            if(this.key == null) {
                if(other.getKey() != null){
                    log.info("...equals5");
                    return false;
                }
            } else if (!this.key.equals(other.getKey())) {
                log.info("...equals6");
                return false;
            }
            log.info("...equals7");
            return true;
        }
    }
}
