package com.example.authapi.users.application.avatar.create;

import com.example.authapi.users.application.dto.AvatarDTO;
import com.example.authapi.users.application.repository.AvatarRepository;
import com.example.authapi.users.domain.exceptions.ExceptionXAlreadyExistException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class CreateAvatarImp implements CreateAvatar {

    private AvatarRepository avatarRepository;


    @Autowired
    public CreateAvatarImp(AvatarRepository avatarRepository){this.avatarRepository=avatarRepository;}

    @Override
    public AvatarDTO create(AvatarDTO avatarDTO) {
        AvatarDTO find = this.avatarRepository.findByUrl(avatarDTO.getUrl());
        if(find!=null){
            throw new ExceptionXAlreadyExistException("File");
        }
        return avatarRepository.create(avatarDTO);
    }

}
