package com.example.authapi.users.application.avatar.update;


import com.example.authapi.users.application.dto.AvatarDTO;
import com.example.authapi.users.application.repository.AvatarRepository;
import com.example.resapi.courses.domain.exceptions.ExceptionXNotExistException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class UpdateAvatarImp implements UpdateAvatar {

    private final AvatarRepository avatarRepository;


    @Autowired
    public UpdateAvatarImp(AvatarRepository avatarRepository) {
        this.avatarRepository = avatarRepository;
    }

    @Override
    public AvatarDTO getFileById(Integer id){
        AvatarDTO avatarDTO = avatarRepository.getById(id);
        if(avatarDTO == null){
            throw new ExceptionXNotExistException("File");
        }
        return avatarDTO;
    }

    @Override
    public AvatarDTO updateFilePath(Integer id, String new_FilePath) {
        AvatarDTO avatarDTO = this.getFileById(id);
        avatarDTO.setPath(new_FilePath);
        avatarRepository.update(avatarDTO);
        return avatarDTO;
    }
}
