package com.example.authapi.users.application.dto;

import lombok.*;

import java.util.List;
import java.util.Objects;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class AvatarDTO {
    private Integer id;
    private List<UserDTO> userDTO;
    private List<Integer> userId;
    private String path;
    private String url;
    private String type;


    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AvatarDTO that = (AvatarDTO) o;
        return Objects.equals(id, that.id) &&  Objects.equals(path, that.path) && Objects.equals(url, that.url) && Objects.equals(type, that.type);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, userId, path, url, type);
    }
}
