package com.example.authapi.users.application.dto;

import lombok.*;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;

import java.io.Serializable;
import java.util.Collection;
import java.util.HashSet;
import java.util.Objects;
import java.util.Set;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class UserDTO implements Serializable, UserDetails {
    private Integer id;
    private String email;
    private String username;
    private String password;
    private String repeatPassword;
    private Integer id_UserSettings;
    private AvatarDTO avatarDTO;
    private String url;
    private Set<RolDTO> roles = new HashSet<>();
    private Collection<? extends GrantedAuthority> authorities;
    private Boolean isEmailVerify;
    @Override
    public Collection<? extends GrantedAuthority> getAuthorities() {
        return this.authorities;
    }

    @Override
    public boolean isAccountNonExpired() {
        return true;
    }

    @Override
    public boolean isAccountNonLocked() {
        return true;
    }

    @Override
    public boolean isCredentialsNonExpired() {
        return true;
    }

    @Override
    public boolean isEnabled() {
        return true;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        UserDTO userDTO = (UserDTO) o;
        return id.equals(userDTO.id) && email.equals(userDTO.email) && Objects.equals(username, userDTO.username) && Objects.equals(password, userDTO.password) && Objects.equals(repeatPassword, userDTO.repeatPassword) && Objects.equals(id_UserSettings, userDTO.id_UserSettings) && roles.equals(userDTO.roles) && Objects.equals(authorities, userDTO.authorities) && Objects.equals(isEmailVerify, userDTO.isEmailVerify);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, email, username, password, repeatPassword, id_UserSettings, roles, authorities, isEmailVerify);
    }
}
