package com.example.authapi.users.application.dto;

import com.example.authapi.shared.enums.LanguageEnum;
import com.example.authapi.shared.enums.VisualizationTypeEnum;
import lombok.*;

import java.util.Objects;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class UserSettingsDTO {
    private Integer id;
    private LanguageEnum languageEnum;
    private VisualizationTypeEnum visualizationTypeEnum;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        UserSettingsDTO that = (UserSettingsDTO) o;
        return Objects.equals(id, that.id) && languageEnum == that.languageEnum && visualizationTypeEnum == that.visualizationTypeEnum;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, languageEnum, visualizationTypeEnum);
    }
}
