package com.example.authapi.users.application.mapper;


import com.example.authapi.users.application.dto.RolDTO;
import com.example.authapi.users.domain.entity.RolDomain;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class RolMapperApplication implements Serializable {
    private static RolMapperApplication instance;

    private RolMapperApplication(){}

    public static RolMapperApplication getInstance(){
        if(instance==null){
            instance = new RolMapperApplication();
        }
        return instance;
    }

    public RolDTO domainToDto(RolDomain rolDomain) {
        if(rolDomain == null){
            return null;
        }
        return RolDTO.builder()
                .id(rolDomain.getId())
                .name(rolDomain.getName())
                .build();
    }

    public RolDomain dtoToDomain(RolDTO rolDTO){
        if(rolDTO == null){
            return null;
        }
        return RolDomain.builder()
                .id(rolDTO.getId())
                .name(rolDTO.getName())
                .build();
    }

    public List<RolDTO> listDomainToListDto(List<RolDomain> rolDomainList){
        if(rolDomainList==null){
            return Collections.emptyList();
        }
        return rolDomainList.stream().map(this::domainToDto).collect(Collectors.toList());
    }

    public List<RolDomain> listDtoToDomainList(List<RolDTO> rolDTOList){
        if(rolDTOList ==null){
            return Collections.emptyList();
        }
        return rolDTOList.stream().map(this::dtoToDomain).collect(Collectors.toList());
    }


}


