package com.example.authapi.users.application.user.create;

import com.example.authapi.users.application.dto.UserDTO;
import com.example.authapi.users.application.repository.UserRepository;
import com.example.authapi.users.domain.exceptions.ExceptionUserAlreadyExistException;
import com.example.authapi.users.domain.exceptions.ExceptionUserNotSaveOnDbSuccessufllyException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class CreateUserImp implements CreateUser{

    private UserRepository userRepository;
    @Autowired
    public CreateUserImp(UserRepository userRepository){this.userRepository=userRepository;}
    public UserDTO create(String email, String username){
        String userEmail = email;
        String userName = username;
        UserDTO find = userRepository.findByEmail(userEmail);
        if(find!=null){
            throw new ExceptionUserAlreadyExistException();
        }
        UserDTO userDTO = UserDTO.builder()
                .username(userName)
                .username(userName)
                .build();
        UserDTO savedUserDTO = userRepository.create(userDTO);
        if(savedUserDTO ==null){
            throw new ExceptionUserNotSaveOnDbSuccessufllyException();
        }
        return savedUserDTO;
    }
}
