package com.example.authapi.users.infrastructure.controller_inputAdapter;

import com.example.authapi.shared.exceptions.TfgException;
import com.example.authapi.shared.valueObject.ResponseDTO;
import com.example.authapi.users.application.userSettings.get.GetUserSettingsByIdImp;
import com.example.authapi.users.application.dto.UserSettingsDTO;
import com.example.authapi.users.infrastructure.controller_inputPort.UserSettingsInputPort;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;


@RestController
@RequestMapping("/userSettings")
@CrossOrigin
public class UserSettingsController implements UserSettingsInputPort {
    private GetUserSettingsByIdImp getUserSettingsByIdImp;

    @Autowired
    public UserSettingsController(GetUserSettingsByIdImp getUserSettingsByIdImp) {
        this.getUserSettingsByIdImp = getUserSettingsByIdImp;
    }

    @Override
    @GetMapping("/get/{userSettingsId}")
    public ResponseDTO<UserSettingsDTO> getUserSettingsById(@PathVariable("userSettingsId") Integer userSettingsId){
        ResponseDTO<UserSettingsDTO> responseDTO = new ResponseDTO<>();
        try {
            UserSettingsDTO userSettingsDTO = this.getUserSettingsByIdImp.getByID(userSettingsId);
            responseDTO.setData(userSettingsDTO);
            responseDTO.addInfo("GET_USER_SETTING_ID_OK");
        }catch(TfgException e){
            responseDTO.setErrorMessages(e.getErrorMessages());
        }catch (Exception e){
            responseDTO.addError(e.getMessage());
        }
        return responseDTO;
    }

    @Override
    @GetMapping("/getAll")
    public ResponseDTO<List<Object>> getAll(){
        //this.getUserSettingsByIdImp.getAllUserSettings();
        ResponseDTO<List<Object>> responseDTO = new ResponseDTO<>();
        try {
            responseDTO.setData(null);
            responseDTO.addInfo("NOT_IMPLEMENTED");
        }catch(TfgException e){
            responseDTO.setErrorMessages(e.getErrorMessages());
        }catch (Exception e){
            responseDTO.addError(e.getMessage());
        }
        return responseDTO;
    }



}
