package com.example.authapi.users.infrastructure.controller_inputPort;

import com.example.authapi.shared.valueObject.ResponseDTO;
import com.example.authapi.users.application.dto.AvatarDTO;
import org.springframework.web.bind.annotation.*;

import java.util.List;

public interface AvatarInputPort {

    @GetMapping("/getAll")
    ResponseDTO<List<AvatarDTO>> getAll();

    @GetMapping("/get/{avatarId}")
    ResponseDTO<AvatarDTO> getAvatarById(@PathVariable("avatarId") Integer avatarId);

    @PostMapping("/create")
    ResponseDTO<AvatarDTO> create(@RequestBody AvatarDTO avatarDTO);

    @DeleteMapping("/delete/{avatarId}")
    ResponseDTO<AvatarDTO> delete(@PathVariable("avatarId") Integer avatarId);
}
