package com.example.authapi.users.infrastructure.controller_inputPort;

import com.example.authapi.shared.valueObject.ResponseDTO;
import com.example.authapi.users.application.dto.UserDTO;
import com.example.authapi.users.application.dto.UserNoExtraDataDTO;
import com.example.authapi.users.infrastructure.body.CreateUserRequestBody;
import com.example.authapi.users.infrastructure.body.RenameUserRequestBody;
import org.springframework.web.bind.annotation.*;

import java.util.List;

public interface UserInputPort  {


    @PostMapping("/create")
    ResponseDTO<UserNoExtraDataDTO> createUser(@RequestBody CreateUserRequestBody createUserRequestBody);

    @GetMapping("/find/email/{userEmail}")
    ResponseDTO<UserNoExtraDataDTO> findUserByEmail(@PathVariable("userEmail") String userEmail);

    @DeleteMapping("/delete/{userId}")
    ResponseDTO<UserNoExtraDataDTO> deleteUser(@PathVariable("userId") Integer userId);

    @GetMapping("/get/{userId}")
    ResponseDTO<UserNoExtraDataDTO> getUserById(@PathVariable("userId") Integer userId);

    @GetMapping("/getAll")
    ResponseDTO<List<UserNoExtraDataDTO>> getAll();

    @PostMapping("/rename")
    ResponseDTO<UserNoExtraDataDTO> renameUser(@RequestBody RenameUserRequestBody renameUserRequestBody);

    @PutMapping("/update")
    ResponseDTO<UserNoExtraDataDTO> updateUser(@RequestBody UserDTO userDto);

    @PostMapping("/avatar/{userId}/{avatarId}")
    ResponseDTO<UserNoExtraDataDTO> asignarAvatarToUser(@PathVariable("userID") Integer userId,@PathVariable("avatarId") Integer avatarId);
}
