package com.example.authapi.users.infrastructure.entity;

import jakarta.persistence.*;
import lombok.*;
import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;

import java.util.List;
import java.util.Objects;

@Entity
@Data
@Getter
@AllArgsConstructor
@NoArgsConstructor
@Builder
@Table(name = "avatar")
public class AvatarEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    private String path;
    private String url;
    private String type;
    @OneToMany(mappedBy = "avatarEntity")
    @NotFound(action= NotFoundAction.IGNORE)
    private List<UserEntity> userEntity;


    @Override
    public String toString() {
        return "AvatarEntity{" +
                "id=" + id +
                ", path='" + path + '\'' +
                ", url='" + url + '\'' +
                ", type='" + type + '\'' +
                ", userEntity=" + userEntity.toString() +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AvatarEntity that = (AvatarEntity) o;
        return Objects.equals(id, that.id) && Objects.equals(path, that.path) && Objects.equals(url, that.url) && Objects.equals(type, that.type) && Objects.equals(userEntity, that.userEntity);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, path, url, type, userEntity);
    }
}
