package com.example.authapi.users.infrastructure.mapper;

import com.example.authapi.users.application.dto.RolDTO;
import com.example.authapi.users.infrastructure.entity.RolEntity;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;
@Service
public class RolMapper implements Serializable {
    private static RolMapper instance;

    private RolMapper(){}

    public static RolMapper getInstance(){
        if(instance==null){
            instance = new RolMapper();
        }
        return instance;
    }

    public RolDTO entityToDto(RolEntity rolEntity){
        if(rolEntity == null){
            return null;
        }
        return RolDTO.builder()
                .id(rolEntity.getId())
                .name(rolEntity.getName())
                .build();
    }

    public RolEntity dtoToEntity(RolDTO rolDTO){
        if(rolDTO ==null){
            return null;
        }
        return RolEntity.builder()
                .id(rolDTO.getId())
                .name(rolDTO.getName())
                .build();
    }

    public List<RolEntity> listDtoToEntityList(List<RolDTO> rolDTOList){
        if(rolDTOList==null){
            return Collections.emptyList();
        }
        return rolDTOList.stream().map(this::dtoToEntity).collect(Collectors.toList());
    }

    public List<RolDTO> listEntityToDtoList(List<RolEntity> rolEntityList){
        if(rolEntityList==null){
            return Collections.emptyList();
        }
        return rolEntityList.stream().map(this::entityToDto).collect(Collectors.toList());
    }


    public Set<RolEntity> setDtoToEntitySet(Set<RolDTO> rolDTOSet){
        if(rolDTOSet==null){
            return Collections.emptySet();
        }
        return rolDTOSet.stream().map(this::dtoToEntity).collect(Collectors.toSet());
    }

    public Set<RolDTO> setEntityToDtoSet(Set<RolEntity> rolEntitySet){
        if(rolEntitySet==null){
            return Collections.emptySet();
        }
        return rolEntitySet.stream().map(this::entityToDto).collect(Collectors.toSet());
    }

}
