package com.example.authapi.users.infrastructure.repository_outputAdapter;

import com.example.authapi.users.application.dto.RolDTO;
import com.example.authapi.users.application.repository.RolRepository;
import com.example.authapi.users.infrastructure.entity.RolEntity;
import com.example.authapi.users.infrastructure.mapper.RolMapper;
import com.example.authapi.users.infrastructure.repository_outputPort.SqlRolRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class SqlRolRepositoryImp implements RolRepository {

    private final SqlRolRepository sqlRolRepository;
    @Autowired
    public SqlRolRepositoryImp(SqlRolRepository sqlRolRepository) {
        this.sqlRolRepository = sqlRolRepository;
    }

    @Override
    public RolDTO getById(Integer rolId) {
        return RolMapper.getInstance().entityToDto(this.sqlRolRepository.findById(rolId).orElse(null));
    }

    public RolDTO getByName(String name) {
        return RolMapper.getInstance().entityToDto(this.sqlRolRepository.getByName(name).orElse(null));
    }

    @Override
    public List<RolDTO> getAll() {
        return RolMapper.getInstance().listEntityToDtoList(this.sqlRolRepository.findAll());
    }

    @Override
    public RolDTO save(RolDTO rolDTO) {
        RolEntity rolEntity = RolMapper.getInstance().dtoToEntity(rolDTO);
        return RolMapper.getInstance().entityToDto(this.sqlRolRepository.save(rolEntity));
    }
}
