package com.example.braintreeapi.controller;

import com.braintreegateway.Result;
import com.braintreegateway.Transaction;
import com.example.braintreeapi.dto.ClientTokenDto;
import com.example.braintreeapi.dto.PurchaseDto;
import com.example.braintreeapi.service.PaymentService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/payment")
@CrossOrigin
@Slf4j
public class PaymentController {

    @Autowired
    PaymentService paymentService;

    @GetMapping("/token")

    public ResponseEntity<ClientTokenDto> getToken(){
        log.info("...getToken...");
        return ResponseEntity.ok(paymentService.getToken());
    }

    @PostMapping("/checkout")
    public ResponseEntity<Result<Transaction>> checkout(@RequestBody PurchaseDto dto){
        log.info("...checkout...");
        return ResponseEntity.ok(paymentService.checkout(dto));
    }
}
