import i18n from "i18next"
import { initReactI18next } from "react-i18next"
import translationCat from "./locales/translation.cat.json"
import translationEng from "./locales/translation.eng.json"
import translationEsp from "./locales/translation.esp.json"

export default function i18nConfigure(){

  const isReturningUser = "lang" in localStorage // Returns true if user already used the website.
  const savedLanguage = JSON.parse(localStorage.getItem("lang")) // Get saved language from previous use.

// Get previously used language in case of returning user or set language to French by default.
  const language = isReturningUser ? savedLanguage : "cat"

  const resources = {
    cat: {
      translation: translationCat,
    },
    eng: {
      translation: translationEng,
    },
    esp: {
      translation: translationEsp,
    },
  }

  // @ts-ignore
  i18n.use(initReactI18next).init({
    resources,
    lng: language,
    keyseparator: false,
    interpolation: {
      escapeValue: false,
    },
  })
}
