import { SuccessComponent } from './success/success.component';
import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { PaymentComponent } from './payment/payment.component';
import { APP_BASE_HREF } from '@angular/common';
import {EmptyRouteComponent} from "./empty-route/empty-route.component";

const routes: Routes = [
  { path: 'braintree/**', component: EmptyRouteComponent },
  { path: 'braintree/payment', component: PaymentComponent },
  { path: 'braintree/success', component: SuccessComponent }
];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  providers: [{ provide: APP_BASE_HREF, useValue: '/' }],
  exports: [RouterModule]
})
export class AppRoutingModule { }
