import { createI18n } from 'vue-i18n';
import esp from "./locales/translation.esp.json";
import eng from "./locales/translation.eng.json";
import cat from "./locales/translation.cat.json";

function loadLocaleMessage() {
  const locales = [{esp: esp}, {eng: eng}, {cat: cat}];
  const messages = {};
  locales.forEach(lang => {
    const key = Object.keys(lang);
    messages[key] = lang[key];
  });
  return messages;
}

// configure i18n
export default createI18n({
  locale: "eng",
  fallbackLocale: "eng",
  messages: loadLocaleMessage(),
})
