import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import {EmptyRouteComponent} from "./empty-route/empty-route.component";
import {APP_BASE_HREF} from "@angular/common";
import {ComunityCoursesComponent} from "./comunityCourses/comunityCourses.component";
import {ChatBodyConversationComponent} from "./chats/chatBodyConversation/chatBodyConversation.component";
import {CreateCourseComponent} from "./course/createCourse/createCourse.component";
import {MyProfileCoursesComponent} from "./myProfileCourses/myProfileCourses.component";
import {MyProfileSettingsComponent} from "./myProfileSettings/myProfileSettings.component";

const routes: Routes = [
  { path: 'resources/**', component: EmptyRouteComponent },
  { path: 'resources/communityCourses', component: ComunityCoursesComponent },
  { path: 'resources/myCourses', component: ChatBodyConversationComponent },
  { path: 'resources/createCourses', component: CreateCourseComponent },
  { path: 'resources/myProfile', component: MyProfileCoursesComponent },
  { path: 'resources/mySettings', component: MyProfileSettingsComponent }
];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  providers: [{ provide: APP_BASE_HREF, useValue: '/' }],
  exports: [RouterModule]
})
export class AppRoutingModule { }
