import {NgModule} from '@angular/core';
import {BrowserModule} from '@angular/platform-browser';
import {MatSlideToggleModule} from '@angular/material/slide-toggle';

import {AppRoutingModule} from './app-routing.module';
import {AppComponent} from './app.component';
import {EmptyRouteComponent} from "./empty-route/empty-route.component";
import {CourseCardsComponent} from "./components/courseCards/courseCards.component";
import {MatCardModule} from "@angular/material/card";
import {MatIconModule} from "@angular/material/icon";
import {MatBadgeModule} from "@angular/material/badge";
import {PersonDetailsCardsComponent} from "./components/personDetailsCard/personDetailsCards.component";
import {PersonStackComponent} from "./components/personStack/personStack.component";
import {ChatBodyConversationComponent} from "./chats/chatBodyConversation/chatBodyConversation.component";
import {ComunityCoursesComponent} from "./comunityCourses/comunityCourses.component";
import {MyProfileCoursesComponent} from "./myProfileCourses/myProfileCourses.component";
import {FormsModule} from "@angular/forms";

import {initializeApp, provideFirebaseApp} from '@angular/fire/app';
import {getStorage, provideStorage} from '@angular/fire/storage';
import {CreateCourseComponent} from "./course/createCourse/createCourse.component";
import {CreatePublicationComponent} from "./course/createPublication/createPublication.component";
import {CreateFileComponent} from "./course/createFile/createFile.component";
import {environment} from "../environments/environment";
import {MyProfileSettingsComponent} from "./myProfileSettings/myProfileSettings.component";
import { ReactiveFormsModule } from '@angular/forms';

@NgModule({
  declarations: [
    AppComponent,
    EmptyRouteComponent,
    CourseCardsComponent,
    PersonDetailsCardsComponent,
    PersonStackComponent,
    ChatBodyConversationComponent,
    ComunityCoursesComponent,
    MyProfileCoursesComponent,
    CreateCourseComponent,
    CreatePublicationComponent,
    CreateFileComponent,
    MyProfileSettingsComponent
  ],
  imports: [
    BrowserModule,
    AppRoutingModule,
    MatSlideToggleModule,
    MatCardModule,
    MatIconModule,
    MatBadgeModule,
    FormsModule,
    ReactiveFormsModule,
    provideFirebaseApp(() => initializeApp((environment.firebaseConfig))),
    provideStorage(() => getStorage())
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }
