import {Component, OnInit} from '@angular/core';
import * as singleSpa from 'single-spa';
import {state$} from '@TfgApp/mf-utility';
import {Subscription} from "rxjs";

@Component({
  selector: 'chat-body-conversation-resources',
  templateUrl: './chatBodyConversation.component.html',
  styleUrls: ['./chatBodyConversation.component.css']
})
export class ChatBodyConversationComponent implements OnInit{
  public nameCurrentUser: any = "";
  public allMyCoursesPublished: any = [];
  public allMyCoursesSubscribed: any = [];
  public allMessagesFromCourseSelected: any = [];
  public showChatBool: any = false;
  public userId: number = 0;
  public idCourse: number = 0;
  public CourseChat: any
  subscription!: Subscription;

  ngOnInit(): void {
    this.ejecutarStart();
  }

  private async ejecutarStart() {
    await this.getCurrentUserFromLocalStorage()
    this.getAllMyCoursesPublished();
    this.getAllMyCoursesSubscribed();
  }

  private async getAllMyCoursesPublished() {
      try{
        const datos=await fetch("http://127.0.0.1:5000/course/coursesbyprofe/"+this.userId)
        const cursos=await datos.json()
        this.allMyCoursesPublished=cursos.data
        console.log("allMyCoursesPublished ",this.allMyCoursesPublished)
      }catch (error) {
        console.error("error: ",error)
        localStorage.removeItem("auth")
        this.subscription = state$.subscribe( (data: any) => {
          console.log("Chat Body Conversation state false")
          state$.next({isLogged: false})
        })
        this.subscription.unsubscribe();
        singleSpa.navigateToUrl("/home/login")
      }
  }

  private async getAllMyCoursesSubscribed() {
    try {
        const datos=await fetch("http://127.0.0.1:5000/course/coursesbyalumn/"+this.userId)
        const cursos=await datos.json()
        this.allMyCoursesSubscribed=cursos.data
      console.log("allMyCoursesSubscribed ",this.allMyCoursesSubscribed)
    } catch (error) {
      console.error("error: ",error)
      localStorage.removeItem("auth")
      this.subscription = state$.subscribe( (data: any) => {
        console.log("Chat Body Conversation state false")
        state$.next({isLogged: false})
      })
      this.subscription.unsubscribe();
      singleSpa.navigateToUrl("/home/login")
    }
  }

  private async getCurrentUserFromLocalStorage() {
    try{
      const petuser=await fetch("http://127.0.0.1:5000/auth/tokentouser/"+localStorage.getItem("auth"))
      const user=await petuser.json()
      console.log("user token: ",user)
      this.userId=user.id
      this.nameCurrentUser=user.username
    }catch (error) {
      localStorage.removeItem("auth")
      this.subscription = state$.subscribe( (data: any) => {
      })
      state$.next({isLogged: false})
      this.subscription.unsubscribe();
      singleSpa.navigateToUrl("/home/login")
    }
  }

  async showChat(myCoursesXItem: any) {
    this.showChatBool = true;
    this.CourseChat=myCoursesXItem
    this.idCourse = myCoursesXItem.id;
    console.log("myCoursesXItem",myCoursesXItem);
    this.transformToHtmlAllMessagesSelected(await this.getAllMessagesSelected(myCoursesXItem));
  }

  async getAllMessagesSelected(curso:any){
    let allMessagesFromCourseSelectedFromBackend = [
      { name: "Maria",
        date: "2023-01-01;14:00:00",
        text: "text1",
        photo:"https://mdbcdn.b-cdn.net/img/Photos/Avatars/avatar-5.webp"
      },
      { name: "Maria",
        date: "2023-01-01;14:01:30",
        text: "text2",
        photo:"https://mdbcdn.b-cdn.net/img/Photos/Avatars/avatar-5.webp"
      },
      { name: "Juana",
        date: "2023-01-01;14:01:30",
        text: "text3",
        photo:"https://mdbcdn.b-cdn.net/img/Photos/Avatars/avatar-4.webp"
      },
      { name: "Maria",
        date: "2023-01-01;14:01:30",
        text: "text4",
        photo:"https://mdbcdn.b-cdn.net/img/Photos/Avatars/avatar-5.webp"
      },
      { name: "test13",
        date: "2023-01-01;15:00:00",
        text: "respuesta5",
        photo:"https://mdbcdn.b-cdn.net/img/Photos/Avatars/avatar-1.webp"
      },
      { name: "Maria",
        date: "2023-01-01;17:00:00",
        text: "Gracias6",
        photo:"https://mdbcdn.b-cdn.net/img/Photos/Avatars/avatar-5.webp"
      },
    ]
    const consulta=await fetch("http://127.0.0.1:5000/chatmessage/find/"+curso.id)
    const datos=await consulta.json()
    console.log("datos getAllMessagesSelected",datos.data)
    return datos.data;
  }

  async transformToHtmlAllMessagesSelected(allMessagesFromCourseSelectedFromBackend: any){
    let lastPersonNameOfChatMessage = "";
    let actualPersonNameOfChatMessage = "";
    let listaMensajesAcumulados: any = [];
    let listaMensajesFinal: any = [];
    let textoMensaje = "";
    let objectJason = this.resetObj();
    let objectJasonUser = this.resetObjUser();
    this.allMessagesFromCourseSelected=[];

    //objectJasonUser1 = await this.findPersonaDataOfActualChatMessageByIdAccount(allMessagesFromCourseSelectedFromBackend[0]["id_account"])
    //console.log('objectJasonUser1',objectJasonUser1)

    for (const element of allMessagesFromCourseSelectedFromBackend) {
      //console.log("element", element)
      actualPersonNameOfChatMessage = element["id_account"];
      //llamar funcion encontrar persona
      objectJasonUser = this.resetObjUser();
      objectJasonUser = await this.findPersonaDataOfActualChatMessageByIdAccount(element["id_account"])
      console.log('element',element)
      console.log('objectJasonUser',objectJasonUser)

      //caso 1: primera persona
      if(lastPersonNameOfChatMessage == ""){
        //construir el obj
        //console.log("ENTRO1")
        lastPersonNameOfChatMessage=actualPersonNameOfChatMessage;
        textoMensaje=element["text"];
        listaMensajesAcumulados.push(textoMensaje);

        //console.log("element[\"name\"]", element["name"]);
        //console.log("element[\"date\"]", element["date"]);
        //console.log("listaMensajesAcumulados", listaMensajesAcumulados);
        //console.log("element[\"photo\"]", element["photo"]);

        objectJason["name"]=objectJasonUser["name"];
        objectJason["time"]=element["time"];
        objectJason["listText"]=listaMensajesAcumulados;
        objectJason["photo"]=objectJasonUser["photo"];

        console.log("objectJason[\"name\"]", objectJason["name"])
        //console.log("objectJason[\"date\"]", objectJason["date"])
        //console.log("objectJason[\"listtext\"]", objectJason["listtext"])
        //console.log("objectJason[\"photo\"]", objectJason["photo"])

        //console.log("objectJason",objectJason);
        //añadir el obj
        //listaMensajesFinal.push(objectJason); //lo añadira el elemento siguiente
        //console.log("listaMensajesFinal.length", listaMensajesFinal.length);
        //console.log("listaMensajesFinal", listaMensajesFinal);
        //console.log("SALGO1");
      }
      //caso 2: hemos cambiado de persona
      // lo primero será guardar el objeto dela persona anterior, y despues crear el objeto nuestro
      else if(actualPersonNameOfChatMessage != lastPersonNameOfChatMessage){
        //guardar el objeto de la persona anterior
        //console.log("ENTRO2");
        listaMensajesFinal.push(objectJason);
        //console.log("listaMensajesFinal", listaMensajesFinal)
        listaMensajesAcumulados=[]
        objectJason = this.resetObj();
        //console.log("reset objectJason",objectJason);

        //crear nuestro objeto con nuestra info
        lastPersonNameOfChatMessage=actualPersonNameOfChatMessage;
        textoMensaje=element["text"];
        listaMensajesAcumulados.push(textoMensaje);
        objectJason["name"]=objectJasonUser["name"];
        objectJason["time"]=element["time"];
        objectJason["listText"]=listaMensajesAcumulados;
        objectJason["photo"]=objectJasonUser["photo"];

        console.log("objectJason[\"name\"]", objectJason["name"])
        //console.log("objectJason[\"date\"]", objectJason["date"])
        //console.log("objectJason[\"listtext\"]", objectJason["listtext"])
        //console.log("objectJason[\"photo\"]", objectJason["photo"])

        //console.log(objectJason);
        //console.log("SALGO2");
      }
      //caso 3: mantenemos la misma persona, por tanto solo quiero actualizar la lista al añadir el nuevo elemento
      else if(actualPersonNameOfChatMessage == lastPersonNameOfChatMessage){
        //console.log("ENTRO3");
        textoMensaje=element["text"];
        listaMensajesAcumulados.push(textoMensaje);
        //console.log("listaMensajesAcumulados",listaMensajesAcumulados);
        //console.log("objectJason",objectJason);
        //console.log("SALGO3");
      }
    }
    listaMensajesFinal.push(objectJason);
    //console.log("listaMensajesFinal", listaMensajesFinal)
    this.allMessagesFromCourseSelected=listaMensajesFinal;
    //console.log(this.allMessagesFromCourseSelected);
  }

  resetObj(){
    return {
      name: "",
      time: "",
      listText: [],
      photo: ""
    };
  }

  resetObjUser(){
    return {
      name: "",
      photo: ""
    };
  }

  async sendNewMessage() {
    const textArea = document.getElementById("textAreaExample2");
    // @ts-ignore
    let text = textArea!.value;
    console.log(text);
    console.log('id_account',this.userId)
    console.log('id_course',this.idCourse)
    const options = {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify({
        id_account: this.userId,
        id_course: this.idCourse,
        text
      }),
    };
    try {
      const consulta = await fetch("http://127.0.0.1:5000/chatmessage/create", options)
      const datos = await consulta.json()
      console.log("datos", datos.data)
      await this.showChat(this.CourseChat)
      // @ts-ignore
      textArea!.value=""
    } catch (error) {
      console.error("error: ", error)
    }
  }

  private async findPersonaDataOfActualChatMessageByIdAccount(idPerson: number) {
    try {
      const person=await fetch("http://127.0.0.1:5000/user/get/"+idPerson)
      const user=await person.json()
      let obj = {
        name: user.data.username,
        photo: user.data.urlAvatar
      }
      return obj
    }catch (error) {
      console.error("error: ", error)
    }
    return {
      name: null,
      photo: null
    }
  }


}
