import {AfterContentInit, Component, Input, OnInit} from '@angular/core';
import {ComunityCoursesComponent} from "../../comunityCourses/comunityCourses.component";
import {state2$} from '@TfgApp/mf-utility';
import {Subscription} from "rxjs";

@Component({
  selector: 'course-cards-resources',
  templateUrl: './courseCards.component.html',
  styleUrls: ['./courseCards.component.css']
})
export class CourseCardsComponent implements OnInit, AfterContentInit{
  public itemsFiltered: any = [];
  @Input() filterOnHijo: any;
  @Input() listOnHijo: any;
  public filterTagsHijo: any = [];
  public itemsVisualizeHijo: any = [];
  public itemsAllHijo: any = [];
  subscription2!: Subscription;

  constructor(private comunityCoursesComponent: ComunityCoursesComponent) {
  }

  ngOnInit(): void{
    this.search();
  }

  ngAfterContentInit() {

  }

  ngOnDestroy(): void {
    this.subscription2?.unsubscribe();
  }

  setItems(): void{
    if(this.filterOnHijo==1){
      this.itemsFiltered = [];
      //filter
      let itemsCat:  any = [];
      let arrayFilterTags: any = [];

      //paso 1: guardarse en un array las tagsFiltradas
      for (let arrayfilterTagsKey of this.filterTagsHijo) {
        arrayFilterTags.push(arrayfilterTagsKey.name);
      }

      //paso2: iterar por todos los items, mirar sus tags y verificar que están presentes en las filtradas
      this.itemsAllHijo.forEach((item: any) => {
        //console.log("item",item);
        itemsCat = item.list_Categories;
        for (let i = 0; i < itemsCat.length; i++) {
          //console.log("itemsTags[i]", itemsTags[i]);
          if(arrayFilterTags.includes(itemsCat[i].name)){
            //console.log("ENTRO2");
            this.itemsFiltered.push(item);
            //si coincide en mas de un filtro, no quiero añadirlo para caada uno pues se duplicará
            break;
          }
        }
      });
      this.itemsVisualizeHijo = [];
      this.itemsVisualizeHijo = this.itemsFiltered;
    }
    else if (this.filterOnHijo==0){
      this.itemsVisualizeHijo = [];
      this.itemsVisualizeHijo = this.listOnHijo;
    }
  }

  sendObj(i: number) {
    return [
      {nickname: this.itemsVisualizeHijo[i].nickname}
    ];
  }

  search() {
    this.filterTagsHijo = this.comunityCoursesComponent.getFilterTags();
    this.itemsVisualizeHijo = this.comunityCoursesComponent.getItemsVisualize();
    this.itemsAllHijo = this.comunityCoursesComponent.getItemsAll()
    this.setItems();
  }

  addToCart(item: any) {
    let listActual: any
    let obj = {
      name: item.name,
      price: item.price
    }
    listActual = localStorage.getItem("items")
    listActual = JSON.parse(listActual);
    if(listActual === null || listActual === undefined){
      listActual=[]
      listActual.push(obj)
      localStorage.setItem("items",JSON.stringify(listActual))
    }else{
      let ob = listActual.filter((ob: { name: any; price: any; }) => obj.name===ob.name && obj.price===ob.price)
      if(ob.length==0){
        listActual.push(obj)
        localStorage.setItem("items",JSON.stringify(listActual))
      }else{
        // No queremos añadirlo pues un curso solo se puede comprar 1 única vez.
        // Si fuesen productos entonces si se podría comprar más de 1 cantidad
      }
    }
    this.subscription2 = state2$.subscribe( (data: any) => {
    })
    state2$.next({nItems: true})
    this.subscription2.unsubscribe();
  }
}
