import {AfterContentInit, Component, OnDestroy, OnInit} from '@angular/core';
import {state$} from '@TfgApp/mf-utility';
import {Subscription} from "rxjs";
import * as singleSpa from 'single-spa';

@Component({
  selector: 'comunity-courses-resources',
  templateUrl: './comunityCourses.component.html',
  styleUrls: ['./comunityCourses.component.css']
})
export class ComunityCoursesComponent implements OnInit, AfterContentInit, OnDestroy{
  public filterTags: any = [];
  public allTags: any = [];
  subscription!: Subscription;
  public nameCurrentUser: any = "";
  public userId?: number;
  public itemsAll: any = [];
  public itemsVisualize: any= [];
  public itemsRecommended: any=[];
  public dataReady: any = false;

  ngOnInit(): void {

  }


  ngAfterContentInit() {
    //console.log('ngAfterContentInit')
    this.ejecutarStart().then(() => {})
    this.cargarTabs().then(() => {
      for (let i = 0; i < this.allTags.length; i++) {
        this.filterTags.push({ ...this.allTags[i]});
      }
    });
  }

  ngOnDestroy(): void {
    this.subscription?.unsubscribe();
  }

  private async ejecutarStart() {
    try{
      const petuser=await fetch("http://127.0.0.1:5000/auth/tokentouser/"+localStorage.getItem("auth"))
      const user=await petuser.json()
      console.log("user token: ",user)
      this.userId=user.id
      this.nameCurrentUser=user.username
    }catch (error) {
      console.error("error: ",error)
      localStorage.removeItem("auth")
      this.subscription = state$.subscribe( (data: any) => {
        state$.next({isLogged: false})
      })
      this.subscription.unsubscribe();
      singleSpa.navigateToUrl("/home/login")
    }
    await this.getAllItems();
    await this.getAllRecommended();
    this.dataReady=true;
  }

  async getAllItems(): Promise<void> {
    this.itemsVisualize = [];
    this.itemsVisualize = this.itemsAll;
    const tarjetas=await fetch("http://127.0.0.1:5000/course/coursesNoId/"+this.userId)
    const data=await tarjetas.json()
    this.itemsAll=data.data
    //this.itemsAll=data.map((x: { data: any; }) => x.data);
    //console.log("Hijo Tarjetas de backen ",this.itemsAll)
  }

  async getAllRecommended(): Promise<void> {
    const tarjetas=await fetch("http://127.0.0.1:5000/course/recommended")
    const data=await tarjetas.json()
    this.itemsRecommended=data.data
  }

  getCommunityCourses() {
    return this.itemsAll
  }

  getRecomended() {
    console.log("recomendados: ",this.itemsRecommended)
    return this.itemsRecommended
  }

  async cargarTabs() {
     const data=await fetch("http://localhost:5000/categories/getAll")
     const datos=await data.json()
     //console.log("Padre Categorias backend",datos.data)
     this.allTags=datos.data
  }

  clearFilters() {
    for (let i = 0; i < this.allTags.length; i++) {
      this.validaCheckboxi(i,0);
    }
  }

  allFilters() {
    for (let i = 0; i < this.allTags.length; i++) {
      this.validaCheckboxi(i,1);
    }
  }

  public getAllTagsElement(i: number){
    return this.allTags[i].name;
  }

  validaCheckboxi (this: any, i: any, bool?: any){
    let checkboxi = document.getElementById('checkbox' + i);
    if(checkboxi === null){
      return;
    }
    if(bool==0){
      // @ts-ignore
      checkboxi.checked = false;
      this.filterTags[i]["name"]=null;
    }else if(bool==1){
      // @ts-ignore
      checkboxi.checked = true;
      this.filterTags[i]["name"]=this.allTags[i]["name"];
    }else{
      // @ts-ignore
      if(checkboxi.checked){
        this.filterTags[i]["name"]=this.allTags[i]["name"];
      }else{
        this.filterTags[i]["name"]=null;
      }
    }
  }

  changeInput(i: number){
    this.validaCheckboxi(i)
    //console.log('filterTags',this.filterTags)
  }

  getFilterTags() {
    return this.filterTags;
  }

  getItemsVisualize() {
    return this.itemsVisualize;
  }

  getItemsAll() {
    return this.itemsAll;
  }

}
