import {Component, OnInit} from '@angular/core';
import {course} from '../../declarations.model';
import * as singleSpa from 'single-spa';
import {state$} from '@TfgApp/mf-utility';
import {Subscription} from "rxjs";

@Component({
  selector: 'create-course-resources',
  templateUrl: './createCourse.component.html',
  styleUrls: ['./createCourse.component.css']
})
export class CreateCourseComponent implements OnInit {
  nameCurrentUser: any;
  courseList: any;
  catselecc: any;
  categoriesList: any;
  newCourse: any;
  subscription!: Subscription;
  activos: any = []

  ngOnInit(): void {
    this.newCourse = new course();
    this.getAllCoursesList();
    this.getAllCategoriesList();
  }

  ngOnDestroy(): void {
    this.subscription?.unsubscribe();
  }
  async getAllCoursesList() {
    const cursos=await fetch("http://127.0.0.1:5000/course/getAll")
    const datos=await cursos.json()
    console.log(datos.data)
    this.courseList=datos.data
    this.createObjEditSave();
    console.log(this.courseList);
  }

  async getAllCategoriesList() {
    const cursos=await fetch("http://localhost:5000/categories/getAll")
    const datos=await cursos.json()
    console.log(datos.data)
    this.categoriesList=datos.data
    console.log(this.categoriesList);
  }


  createObjEditSave() {
    for (const objElement of this.courseList) {
      objElement["edit"]=false;
      objElement["desplegar"]=false;
    }
  }

  changeEditValue(course: any) {
    console.log("entro en changeEditValue")
    course["edit"]=!course["edit"];
  }
  desplegarCourse(course: any) {
    course["desplegar"]=!course["desplegar"];
  }

  async updateCourse(course: any,c:number) {
    console.log("entro en updateCourse")
    console.log("course ",course, " c: ",c)
    const n=document.getElementById("name"+c)
    //@ts-ignore
    const newname=n?.value
    console.log("Valor de name: ",newname)
    const p=document.getElementById("price"+c)
    //@ts-ignore
    const newprice=p?.value
    console.log("Valor de price: ",newprice)
    try {
      const resul=await fetch("http://127.0.0.1:5000/course/update",{
        method: 'PUT',
        headers: {
          'Content-Type': 'application/json'
          // 'Content-Type': 'application/x-www-form-urlencoded',
        },
        body: JSON.stringify({
          name: newname,
          price: newprice,
          id: course.id
        })
      })
      this.getAllCoursesList()  
   } catch (error) {
    console.error("error: ",error)
    console.error("No se ha podido modificar el curso")
   }
    course["edit"]=!course["edit"];
  }

  async createCourse() {
    const token = localStorage.getItem("auth")
    let user
    let datos
    if (token!==undefined && token!==null){
      try{
        user = await fetch("http://127.0.0.1:5000/auth/tokentouser/"+token)
        datos= await user.json()
        console.log("user: ",user)
        console.log("user.json: ",datos)
     }catch (error) {
      console.error("error: ",error)
      localStorage.removeItem("auth")
      this.subscription = state$.subscribe( (data: any) => {
      })
      state$.next({isLogged: false})
      this.subscription.unsubscribe();
      singleSpa.navigateToUrl("/home/login")
     }
     try {
        const resul=await fetch("http://127.0.0.1:5000/course/create",{
          method: 'POST',
          headers: {
            'Content-Type': 'application/json'
            // 'Content-Type': 'application/x-www-form-urlencoded',
          },
          body: JSON.stringify({
            name: this.newCourse.name,
            price: this.newCourse.price,
            list_id_professors: [datos.id]
          })
        })
        const dats=await resul.json()
        const curso=dats.data
        this.newCourse.name=""
        this.newCourse.price=undefined
        this.asignarCategoriasCurso(curso.name)
        this.getAllCoursesList()  
     } catch (error) {
      console.error("error: ",error)
      console.error("No se ha podido crear el curso")
     }
     
    }else{
      singleSpa.navigateToUrl("/home/login")
    }
    
  }

  async asignarCategoriasCurso(ncurso:string) {
    for (const cat of this.activos) {
      try {
        const curso=await fetch("http://127.0.0.1:5000/course/categoria/"+ncurso+"/"+cat,{
          method: 'POST',
          headers: {
            'Content-Type': 'application/json'
            // 'Content-Type': 'application/x-www-form-urlencoded',
          }})
      } catch (error) {
        console.error(error)
      }
    }
  }

  cambiarcat($event: Event, cat: any) {
    //@ts-ignore
    const activo=$event.target.checked
    console.log(cat, activo)
    if (activo) {
      this.activos.push(cat.name)
    }else{
      this.activos=this.activos.filter((c: any) => c!==cat.name)
    }
    console.log(this.activos)
  }

  catvisible(cat: any){
    if (this.activos.length ==4)
      if( this.activos.find((el:any) => el === cat.name)){
        return false
      }else return true;
    return false
  }

}
