import {Component, Input, OnInit} from '@angular/core';
import {file, file_BBDD, publication, userid} from '../../declarations.model';
import {Storage, getDownloadURL, ref, uploadBytesResumable} from '@angular/fire/storage';
import * as singleSpa from 'single-spa';
import {state$} from '@TfgApp/mf-utility';
import {Subscription} from "rxjs";

@Component({
  selector: 'create-file-resources',
  templateUrl: './createFile.component.html',
  styleUrls: ['./createFile.component.css']
})
export class CreateFileComponent implements OnInit {
  CurrentUser: any;
  fileList: any;
  newFile: any;
  subscription!: Subscription;
  @Input() publication: publication | undefined;

  constructor(private storage: Storage) {
  }

  ngOnInit(): void {
    this.newFile = new file();
    this.getUserByToken()
    this.getAllFilesList()
  }

  async getAllFilesList() {
    const datosfile=await fetch("http://127.0.0.1:5000/publication/find/files/"+this.publication?.id)
    const files=await datosfile.json()
    console.log("ficheros: ",files.data)
    this.fileList=files.data
    console.log(this.fileList);
  }

  async getUserByToken() {
    const token = localStorage.getItem("auth")
    let user
    let datos
    if (token!==undefined && token!==null){
      try{
        user = await fetch("http://127.0.0.1:5000/auth/tokentouser/"+token)
        datos= await user.json()
        console.log("user: ",user)
        console.log("user.json: ",datos)
        this.CurrentUser=datos
      }catch (error) {
        localStorage.removeItem("auth")
        this.subscription = state$.subscribe( (data: any) => {})
        state$.next({isLogged: false})
        this.subscription.unsubscribe();
        singleSpa.navigateToUrl("/home/login")
      }
    }
  }

  async changeDeleteValue(file: any) {
    console.log("llamar a borrar file",file)
    try {
      const eliminar=await fetch("http://127.0.0.1:5000/file/delete/"+file.id,
      {method: 'DELETE',
      headers: {
        "Authorization": "Bearer "+localStorage.getItem("auth"), //Agregado
      }})
      this.getAllFilesList()
    } catch (error) {
      console.error("ha ocurrido un ERROR AL ELIMINAR FICHERO: ",error)
      localStorage.removeItem("auth")
      this.subscription = state$.subscribe( (data: any) => {
      })
      state$.next({isLogged: false})
      this.subscription.unsubscribe();
      singleSpa.navigateToUrl("/home/login")
    }
  }

  uploadFile() {
    const fileArea = document.getElementById("newFormFile");
    const fileEntry =new file()
    //@ts-ignore
    fileEntry.fileFile=fileArea.files[0];
    const file1 = fileEntry.fileFile
    if(file1 === undefined){
      return;
    }
    //console.log(file1);
    const nameCurrentUser = this.CurrentUser.username;

    //necesitamos una referencia dentro del storage -> la ruta
    const imgRef =ref(this.storage, `images/${nameCurrentUser}/${file1.name}`);

    //ahora vamos a subir la imagen al storage
    const uploadTask:any = uploadBytesResumable(imgRef, file1)
    uploadTask.on('state_changed',(snapshot:any)=>{
        // Observe state change events such as progress, pause, and resume
        // Get task progress, including the number of bytes uploaded and the total number of bytes to be uploaded
        const progress = (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
        console.log('Upload is ' + progress + '% done');
        switch (snapshot.state) {
          case 'paused':
            console.log('Upload is paused');
            break;
          case 'running':
            console.log('Upload is running');
            break;
        }
      },(error:any)=>{
        console.error("no se ha cargado")
      },
      () => {
        // Handle successful uploads on complete
        // For instance, get the download URL: https://firebasestorage.googleapis.com/...
        getDownloadURL(uploadTask.snapshot.ref).then((downloadURL) => {
          console.log('File available at', downloadURL);
          console.log(uploadTask._blob.type_)
          console.log(uploadTask._blob.size_)
          console.log(uploadTask._metadata.bucket)
          console.log(uploadTask._metadata.fullPath)
          fileEntry.path = uploadTask._metadata.fullPath;
          fileEntry.url = downloadURL;
          fileEntry.type = uploadTask._blob.type_;
          console.log('file',file);
          const userid1 = new userid();
          userid1.id=this.publication!.id;
          const file_BBDD1 = new file_BBDD();
          file_BBDD1.path=fileEntry.path;
          file_BBDD1.url=fileEntry.url;
          file_BBDD1.type=fileEntry.type;
          file_BBDD1.publicationDTO=userid1;
          this.guardar_BBDD(file_BBDD1)
        });
      }
    );
  }

  async guardar_BBDD(obj:file_BBDD) {
    console.log("entro guardar_BBDD obj", obj)
    console.log("asignar idacc")
    obj!.id_account=this.CurrentUser.id
    try {
      console.log("fetch")
      const user = await fetch("http://127.0.0.1:5000/file/create",{
        method: "POST",
        headers: {
          'Content-Type': 'application/json',
          "Authorization": "Bearer "+localStorage.getItem("auth")
        },
        body: JSON.stringify(obj)
      })
      console.log("salgo fetch", user)
    } catch (error) {
      console.error("error al crear el fichero en BBDD: ",error)
    }
    console.log("fin")
  }
  
}
