import {Component, Input, OnInit} from '@angular/core';
import {publication} from '../../declarations.model';


@Component({
  selector: 'create-publication-resources',
  templateUrl: './createPublication.component.html',
  styleUrls: ['./createPublication.component.css']
})
export class CreatePublicationComponent implements OnInit {
  nameCurrentUser: any;
  publicationList: any;
  newPublication: any;
  @Input() courseOnHijoId: any;
  @Input() courseOnHijoName: any;

  ngOnInit(): void {
    console.log("Id: ",this.courseOnHijoId," Name: ", this.courseOnHijoName);
    this.newPublication = new publication();
    this.getAllPublicationsList();
  }

  async getAllPublicationsList() {
    this.publicationList = [
      {title:"pub1",description:"des1"},
      {title:"pub2",description:"des2"},
      {title:"pub3",description:"des3"},
      {title:"pub4",description:"des4"},
      {title:"pub5",description:"des5"},
      {title:"pub6",description:"des6"},
      {title:"pub7",description:"des7"},
    ];
    const searchpub=await fetch("http://127.0.0.1:5000/course/publications/"+this.courseOnHijoName);
    const datos=await searchpub.json();
    console.log("datos: ",datos.data)
    this.publicationList=datos.data
    this.createObjEditSave();
    console.log(this.publicationList);
  }

  createObjEditSave() {
    for (const objElement of this.publicationList) {
      objElement["edit"]=false;
      objElement["desplegar"]=false;
    }
  }

  changeEditValue(publication: any) {
    publication["edit"]=!publication["edit"];
  }
  desplegarPublication(publication: any) {
    publication["desplegar"]=!publication["desplegar"];
  }

  async updatePublication(publication: any, p:number) {
    console.log("entro en updatePublication")
    console.log("publication ",publication, " p: ",p)
    const n=document.getElementById("title"+p)
    //@ts-ignore
    const newtitle=n?.value
    console.log("Valor de newtitle: ",newtitle)
    const publi=document.getElementById("publication"+p)
    //@ts-ignore
    const newpubli=publi?.value
    console.log("Valor de newpubli: ",newpubli)
    try {
      const resul=await fetch("http://127.0.0.1:5000/publication/update",{
        method: 'PUT',
        headers: {
          'Content-Type': 'application/json'
          // 'Content-Type': 'application/x-www-form-urlencoded',
        },
        body: JSON.stringify({
          id: publication.id,
          title: newtitle,
          description: newpubli,
        })
      })
      this.getAllPublicationsList()  
   } catch (error) {
    console.error("error: ",error)
    console.error("No se ha podido modificar el curso")
   }
   publication["edit"]=!publication["edit"];
  }

  async createPublication() {
     try {
      const resul=await fetch("http://127.0.0.1:5000/publication/create",{
        method: 'POST',
        headers: {
          'Content-Type': 'application/json'
          // 'Content-Type': 'application/x-www-form-urlencoded',
        },
        body: JSON.stringify({
          title: this.newPublication.title,
          description: this.newPublication.description,
          courseDTO: {"id": this.courseOnHijoId}
        })
      })
      this.newPublication.title=""
      this.newPublication.description=undefined    
      this.getAllPublicationsList()  
    } catch (error) {
    console.error("error: ",error)
    console.error("No se ha podido crear la publicacion")
    }
     
  }

}
