import {Component} from '@angular/core';
import {getDownloadURL, ref, Storage, uploadBytesResumable} from '@angular/fire/storage';
import * as singleSpa from 'single-spa';
import {state$} from '@TfgApp/mf-utility';
import {Subscription} from "rxjs";
import {file, file_BBDD2} from "../declarations.model";

@Component({
  selector: 'my-profileSettings-resources',
  templateUrl: './myProfileSettings.component.html',
  styleUrls: ['./myProfileSettings.component.css']
})
export class MyProfileSettingsComponent {
  CurrentUser: any
  subscription!: Subscription;

  constructor(private storage: Storage) {
  }

  ngOnInit(): void {
    this.setCurrentUser();
  }

  private async setCurrentUser() {
    try {
      const idPerson=await fetch("http://127.0.0.1:5000/auth/tokentouser/"+localStorage.getItem("auth"))
      const idPersonJson=await idPerson.json()
      console.log("idPerson",idPersonJson)
      this.CurrentUser={...idPersonJson}
    }catch (error) {
      localStorage.removeItem("auth")
      this.subscription = state$.subscribe( (data: any) => {
      })
      state$.next({isLogged: false})
      this.subscription.unsubscribe();
      singleSpa.navigateToUrl("/home/login")
    }
  }

  uploadFile() {
    const fileArea = document.getElementById("newFormFile");

    const fileEntry =new file()
    //@ts-ignore
    fileEntry.fileFile=fileArea.files[0];
    const file1 = fileEntry.fileFile
    if(file1 === undefined){
      return;
    }
    //console.log(file1);
    const nameCurrentUser = this.CurrentUser.username;

    //necesitamos una referencia dentro del storage -> la ruta
    const imgRef =ref(this.storage, `images/${nameCurrentUser}/${file1.name}`);

    //ahora vamos a subir la imagen al storage
    const uploadTask:any = uploadBytesResumable(imgRef, file1)
    uploadTask.on('state_changed',(snapshot:any)=>{
        // Observe state change events such as progress, pause, and resume
        // Get task progress, including the number of bytes uploaded and the total number of bytes to be uploaded
        const progress = (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
        console.log('Upload is ' + progress + '% done');
        switch (snapshot.state) {
          case 'paused':
            console.log('Upload is paused');
            break;
          case 'running':
            console.log('Upload is running');
            break;
        }
      },(error:any)=>{
        console.error("no se ha cargado")
      },
      () => {
        // Handle successful uploads on complete
        // For instance, get the download URL: https://firebasestorage.googleapis.com/...
        getDownloadURL(uploadTask.snapshot.ref).then((downloadURL) => {
          console.log('File available at', downloadURL);
          console.log(uploadTask._blob.type_)
          console.log(uploadTask._blob.size_)
          console.log(uploadTask._metadata.bucket)
          console.log(uploadTask._metadata.fullPath)
          fileEntry.path = uploadTask._metadata.fullPath;
          fileEntry.url = downloadURL;
          fileEntry.type = uploadTask._blob.type_;
          console.log('file',file);
          //const userid1 = new userid();
          //userid1.id=this.publication!.id;
          const file_BBDD1 = new file_BBDD2();
          file_BBDD1.path=fileEntry.path;
          file_BBDD1.url=fileEntry.url;
          file_BBDD1.type=fileEntry.type;
          file_BBDD1.userId=this.CurrentUser.id;
          this.guardar_BBDD(file_BBDD1, file_BBDD1.url)
        });
      }
    );
  }
  async guardar_BBDD(obj:{}, url:any) {
    console.log("entro guardar_BBDD obj", obj)
    try {
      console.log("fetch")
      const user = await fetch("http://127.0.0.1:5000/avatar/create",{
        method: "POST",
        headers: {
          'Content-Type': 'application/json',
          "Authorization": "Bearer "+localStorage.getItem("auth")
        },
        body: JSON.stringify(obj)
      })
      console.log("salgo fetch", user)
    } catch (error) {
      console.error("error al crear el fichero en BBDD: ",error)
    }
    console.log("fin")
    //@ts-ignore
    const username = document.getElementById("username")?.value;
    //@ts-ignore
    const password = document.getElementById("password")?.value;

    console.log('uploadInfo')
    console.log('url',url)
    console.log('username',username)
    console.log('password',password)
    /*
    //@ts-ignore
    this.objModifi={...this.objModifi, url:this.Url}
    console.log("voy a procesafile con",this.objModifi)
    this.procesafile();*/
  }

  async uploadInfo() {
    this.uploadFile();
    //@ts-ignore

    //console.warn(this.profileForm.value);
    // TODO subir this.profileForm.avatarfile

    const options = {
      method: 'UPDATE',
      headers: {
      'Content-Type': 'application/json',
      },
      //body: JSON.stringify(this.objModifi),
      };
    console.log("options",options)
    try{
      //const resu=await fetch("http://localhost:5000/user/update",options)
      //const datos=await resu.json()
      //const user=datos.data
     // console.log("user",user)
    }catch (error){
      console.error("ha ocurrido el siguiente error en el update",error)
    }
  }
}
