package com.example.resapi.courses.application.chatMessage.create;

import com.example.resapi.courses.application.dto.ChatMessageDTO;
import com.example.resapi.courses.application.repository.ChatMessageRepository;
import com.example.resapi.courses.domain.exceptions.ExceptionXAlreadyExistException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class CreateChatMessageImp implements CreateChatMessage {

    private ChatMessageRepository chatMessageRepository;

    @Autowired
    public CreateChatMessageImp(ChatMessageRepository chatMessageRepository){
        this.chatMessageRepository = chatMessageRepository;
    }

    @Override
    public ChatMessageDTO create(ChatMessageDTO chatMessageDTO) {
        ChatMessageDTO find = this.chatMessageRepository.findByLocalDate(chatMessageDTO.getTime());
        if(find!=null){
            throw new ExceptionXAlreadyExistException("Notification");
        }
        return chatMessageRepository.create(chatMessageDTO);
    }
}
