package com.example.resapi.courses.application.chatMessage.update;


import com.example.resapi.courses.application.dto.ChatMessageDTO;
import com.example.resapi.courses.application.mapper.ChatMessageMapperApplication;
import com.example.resapi.courses.domain.entity.ChatMessageDomain;
import com.example.resapi.courses.domain.exceptions.ExceptionXNotExistException;
import com.example.resapi.courses.application.repository.ChatMessageRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class UpdateChatMessageImp implements UpdateChatMessage {

    private final ChatMessageRepository chatMessageRepository;

    @Autowired
    public UpdateChatMessageImp(ChatMessageRepository chatMessageRepository) {
        this.chatMessageRepository = chatMessageRepository;
    }

    @Override
    public ChatMessageDTO getNotificationById(Integer id){
        ChatMessageDTO chatMessageDTO = chatMessageRepository.getById(id);
        if(chatMessageDTO == null){
            throw new ExceptionXNotExistException("Notification");
        }
        return chatMessageDTO;
    }

    @Override
    public ChatMessageDTO updateText(Integer id, String new_text) {
        ChatMessageDomain chatMessageDomain = ChatMessageMapperApplication.getInstance().dtoToDomain(this.getNotificationById(id));
        chatMessageDomain.updateText(new_text);
        ChatMessageDTO chatMessageDTO= ChatMessageMapperApplication.getInstance().domainToDto(chatMessageDomain);
        return chatMessageRepository.update(chatMessageDTO);
    }

}
