package com.example.resapi.courses.application.course.create;

import com.example.resapi.courses.application.dto.CourseDTO;
import com.example.resapi.courses.application.dto.PublicationDTO;
import com.example.resapi.courses.application.repository.CourseRepository;
import com.example.resapi.courses.domain.exceptions.ExceptionXAlreadyExistException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Set;

@Service
public class CreateCourseImp implements CreateCourse {

    private CourseRepository courseRepository;

    @Autowired
    public CreateCourseImp(CourseRepository courseRepository){this.courseRepository=courseRepository;}

    @Override
    public CourseDTO create(String name, Set<Integer> array_professors, Set<Integer> array_students, List<PublicationDTO> array_publications) {
        CourseDTO find = this.courseRepository.findByName(name);
        if(find!=null){
            throw new ExceptionXAlreadyExistException("Course");
        }
        CourseDTO course = CourseDTO.builder()
                .name(name)
                .list_id_professors(array_professors)
                .list_id_students(array_students)
                .list_id_publications(array_publications)
                .build();

        return courseRepository.create(course);
    }
}
