package com.example.resapi.courses.application.course.get;

import com.example.resapi.courses.application.dto.CategoriesDTO;
import com.example.resapi.courses.application.dto.CourseDTO;
import com.example.resapi.courses.application.repository.CourseRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

@Service
public class GetCourseByIdImp implements GetCourseById {
    private final CourseRepository courseRepository;

    @Autowired
    public GetCourseByIdImp(CourseRepository courseRepository) {
        this.courseRepository = courseRepository;
    }

    @Override
    public CourseDTO getCourseByID(Integer id) {
        return courseRepository.getById(id);
    }

    @Override
    public CourseDTO findByName(String name) {
        CourseDTO courseDTO = courseRepository.findByName(name);
        if (courseDTO!=null) {
            return this.getCourseByID(courseDTO.getId());
        }
        return null;
    }

    @Override
    public List<CourseDTO> getAllCourses() {
        return courseRepository.getAll();
    }

    @Override
    public List<CourseDTO> getAllCoursesbyuser() {
        return courseRepository.getAll();
    }

    @Override
    public CourseDTO create(CourseDTO course) {
        return this.courseRepository.create(course);
    }

    @Override
    public CourseDTO delete(Integer id) {
        return this.courseRepository.delete(id);
    }
    @Override
    public CourseDTO delete(String name) {
        CourseDTO course = courseRepository.findByName(name);
        if (course==null)
            return null;
        return delete(course.getId());
    }

    @Override
    public CourseDTO asignarCatego(CourseDTO course, CategoriesDTO categoriesEntity) {
        List<CategoriesDTO> categoriesEntityList =course.getList_Categories();
        if (categoriesEntityList ==null)
            categoriesEntityList =new ArrayList<>();
        categoriesEntityList.add(categoriesEntity);
        course.setList_Categories(categoriesEntityList);
        return courseRepository.update(course);
    }

    @Override
    public CourseDTO desasignarCatego(CourseDTO course, CategoriesDTO categoriesEntity) {
        List<CategoriesDTO> categoriesDTOList =course.getList_Categories();
        List<CategoriesDTO> categoriesDTOList2=categoriesDTOList.stream().filter(categoriesDTO -> !Objects.equals(categoriesDTO.getName(), categoriesEntity.getName()) && !Objects.equals(categoriesDTO.getId(), categoriesEntity.getId())).toList();
        course.setList_Categories(categoriesDTOList2);
        CourseDTO courseDTO = courseRepository.update(course);
        return courseDTO;
    }
}
