package com.example.resapi.courses.application.dto;

import lombok.*;

import java.util.List;
import java.util.Objects;
import java.util.Set;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class CourseDTO {
    private Integer id;
    private String name;
    private Float price;
    private Set<Integer> list_id_professors;
    private Set<Integer> list_id_students;
    private List<PublicationDTO> list_id_publications;
    private List<CategoriesDTO> list_Categories;


    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        CourseDTO that = (CourseDTO) o;
        return Objects.equals(id, that.id) && Objects.equals(name, that.name);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name);
    }
}
