package com.example.resapi.courses.application.file.create;

import com.example.resapi.courses.application.dto.FileDTO;
import com.example.resapi.courses.application.repository.FileRepository;
import com.example.resapi.courses.domain.exceptions.ExceptionXAlreadyExistException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class CreateFileImp implements CreateFile {

    private FileRepository fileRepository;


    @Autowired
    public CreateFileImp(FileRepository fileRepository){this.fileRepository=fileRepository;}

    @Override
    public FileDTO create(FileDTO fileDTO) {
        FileDTO find = this.fileRepository.findByUrl(fileDTO.getUrl());
        if(find!=null){
            throw new ExceptionXAlreadyExistException("File");
        }
        return fileRepository.create(fileDTO);
    }

}
