package com.example.resapi.courses.application.file.update;


import com.example.resapi.courses.application.dto.FileDTO;
import com.example.resapi.courses.application.repository.FileRepository;
import com.example.resapi.courses.domain.exceptions.ExceptionXNotExistException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class UpdateFileImp implements UpdateFile {

    private final FileRepository fileRepository;


    @Autowired
    public UpdateFileImp(FileRepository fileRepository) {
        this.fileRepository = fileRepository;
    }

    @Override
    public FileDTO getFileById(Integer id){
        FileDTO fileDTO = fileRepository.getById(id);
        if(fileDTO == null){
            throw new ExceptionXNotExistException("File");
        }
        return fileDTO;
    }

    @Override
    public FileDTO updateFilePath(Integer id, String new_FilePath) {
        FileDTO fileDTO = this.getFileById(id);
        fileDTO.setPath(new_FilePath);
        fileRepository.update(fileDTO);
        return fileDTO;
    }
}
