package com.example.resapi.courses.application.mapper;

import com.example.resapi.courses.application.dto.CategoriesDTO;
import com.example.resapi.courses.domain.entity.CategoriesDomain;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class CategoriesMapperApplication implements Serializable {
    private static CategoriesMapperApplication instance;

    private CategoriesMapperApplication(){}

    public static CategoriesMapperApplication getInstance(){
        if(instance==null){
            instance = new CategoriesMapperApplication();
        }
        return instance;
    }

    public CategoriesDTO domainToDto(CategoriesDomain categoriesDomain){
        if(categoriesDomain ==null){
            return null;
        }
        return CategoriesDTO.builder()
                .id(categoriesDomain.getId())
                .name(categoriesDomain.getName())
                .build();
    }

    public CategoriesDomain dtoToDomain(CategoriesDTO categoriesDTO){
        if(categoriesDTO == null){
            return null;
        }
        return CategoriesDomain.builder()
                .id(categoriesDTO.getId())
                .name(categoriesDTO.getName())
                .build();
    }

    public List<CategoriesDTO> listDomainToListDto(List<CategoriesDomain> categoriesDomainList){
        if(categoriesDomainList==null){
            return Collections.emptyList();
        }
        return categoriesDomainList.stream().map(this::domainToDto).collect(Collectors.toList());
    }

    public List<CategoriesDomain> listDtoToDomainList(List<CategoriesDTO> categoriesDTOList){
        if(categoriesDTOList ==null){
            return Collections.emptyList();
        }
        return categoriesDTOList.stream().map(this::dtoToDomain).collect(Collectors.toList());
    }


}
