package com.example.resapi.courses.application.publication.create;

import com.example.resapi.courses.application.dto.PublicationDTO;
import com.example.resapi.courses.application.repository.PublicationRepository;
import com.example.resapi.courses.domain.exceptions.ExceptionXAlreadyExistException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class CreatePublicationImp implements CreatePublication {

    private PublicationRepository publicationRepository;

    @Autowired
    public CreatePublicationImp(PublicationRepository publicationRepository){this.publicationRepository=publicationRepository;}

    @Override
    public PublicationDTO create(PublicationDTO publication) {
        PublicationDTO obj = this.publicationRepository.findByTitle(publication.getTitle());
        if(obj!=null){
            throw new ExceptionXAlreadyExistException("Publication");
        }
        return publicationRepository.create(publication);
    }
}
