package com.example.resapi.courses.domain.entity;

import lombok.*;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

@Builder
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
public class CourseDomain implements Serializable {
    private Integer id;
    private String name;
    private Float price;
    private List<CategoriesDomain> list_Categories;
    private Set<Integer> list_id_professors;
    private Set<Integer> list_id_students;
    private List<PublicationDomain> list_id_publications;

    public void rename (String name){
        this.name=name;
    }

    public void addProfessor(Integer id_professor) {
        this.getList_id_professors().add(id_professor);
    }

    public void addStudent(Integer id_student) {
        this.getList_id_students().add(id_student);
    }

    /*
    public void addPublication(Integer id_publication) {
        this.getList_id_publications().add(id_publication);
    }
*/
    public Integer removeProfessor(Integer id_professor) {
        return this.removeElement(id_professor,new ArrayList<>(this.getList_id_professors()));
    }

    public Integer removeStudent(Integer id_student) {
        return this.removeElement(id_student, new ArrayList<>(this.getList_id_students()));
    }

    /*
    public Integer removePublication(PublicationEntity publication) {
        return this.removeElement(publication.getId(),new ArrayList<>(this.getList_id_publications()));
    }
*/
    private Integer removeElement(Integer id, List<Integer> list){
        int index =list.indexOf(id);
        return list.remove(index);
    }

    public Boolean removePosition(Integer id, List<Integer> list){
        if(list.size()>id){
            Integer index =list.get(id);
            return list.remove(index);
        }
        return false;
    }

}
