package com.example.resapi.courses.infrastructure.controller_inputPort;

import com.example.resapi.courses.application.dto.CategoriesDTO;
import com.example.resapi.shared.valueObject.ResponseDTO;
import org.springframework.web.bind.annotation.*;

import java.util.List;

public interface CategoriesInputPort {

    @GetMapping("/get/{categoriesId}")
    ResponseDTO<CategoriesDTO> getCategoriesById(@PathVariable("categoriesId") Integer id);

    @GetMapping("/find/{categoriesName}")
    ResponseDTO<CategoriesDTO> getCategoriesByName(@PathVariable("categoriesName") String name);
    @GetMapping("/getAll")
    ResponseDTO<List<CategoriesDTO>> getAll();

    @PostMapping("/create")
    ResponseDTO<CategoriesDTO> createCategories (@RequestBody CategoriesDTO categoriesDTO);

    @DeleteMapping("/delete/{courseId}")
    ResponseDTO<CategoriesDTO> deleteCategoriesByCourseId(@PathVariable("courseId") Integer id);

    @DeleteMapping("/delete/name/{courseName}")
    ResponseDTO<CategoriesDTO> deleteCategoriesByCourseName(@PathVariable("courseName") String name);
}
