package com.example.resapi.courses.infrastructure.controller_inputPort;

import com.example.resapi.courses.application.dto.ChatMessageDTO;
import com.example.resapi.shared.valueObject.ResponseDTO;
import org.springframework.web.bind.annotation.*;

import java.util.List;

public interface ChatMessageInputPort {

    @GetMapping("/get/{chatmessageId}")
    ResponseDTO<ChatMessageDTO> getChatMessageById(@PathVariable("chatmessageId") Integer notificationId);

    @GetMapping("/getAll")
    ResponseDTO<List<ChatMessageDTO>> getAll();

    @GetMapping("/find/{courseId}")
    ResponseDTO<List<ChatMessageDTO>> findbycourse(@PathVariable("courseId") Integer courseId);

    @PostMapping("/create")
    ResponseDTO<ChatMessageDTO> create(@RequestBody ChatMessageDTO chatMessageDTO);

    @DeleteMapping("/delete/{chatMessageId}")
    ResponseDTO<ChatMessageDTO> deleteChatMessageByIdMessage(@PathVariable("chatMessageId") Integer chatMessageId);
}
