package com.example.resapi.courses.infrastructure.controller_inputPort;

import com.example.resapi.courses.application.dto.CourseDTO;
import com.example.resapi.courses.application.dto.PublicationDTO;
import com.example.resapi.shared.valueObject.ResponseDTO;
import org.springframework.web.bind.annotation.*;

import java.util.List;

public interface CourseInputPort {

    @GetMapping("/get/{courseId}")
    ResponseDTO<CourseDTO> getCourseById(@PathVariable("courseId") Integer rolId);

    @GetMapping("/find/{courseName}")
    ResponseDTO<CourseDTO> getCourseByName(@PathVariable("courseName") String name);

    @GetMapping("/publications/{courseName}")
    ResponseDTO<List<PublicationDTO>> getCoursePublicationsByCourseName(@PathVariable("courseName") String name);

    @GetMapping("/getAll")
    ResponseDTO<List<CourseDTO>> getAll();

    @PostMapping("/create")
    ResponseDTO<CourseDTO> createCourse (@RequestBody CourseDTO course);

    @DeleteMapping("/delete/{courseId}")
    ResponseDTO<CourseDTO> deleteCourse(@PathVariable("courseId") Integer id);

    @DeleteMapping("/delete/name/{courseName}")
    ResponseDTO<CourseDTO> deleteCourseByName(@PathVariable("courseName") String name);

    @PostMapping("/categoria/{courseName}/{categoriaName}")
    ResponseDTO<CourseDTO> addCategoryToCourse(@PathVariable("courseName") String cursoName, @PathVariable("categoriaName") String categoName);

    @PostMapping("/quitarcategoria/{courseName}/{categoriaName}")
    ResponseDTO<CourseDTO> deleteCategoryToCourse(@PathVariable("courseName") String cursoName, @PathVariable("categoriaName") String categoName);

    @PutMapping("update")
    ResponseDTO<CourseDTO> updateCourse(@RequestBody CourseDTO course);

    @GetMapping("coursesbyprofe/{courseId}")
    ResponseDTO<List<CourseDTO>> getAllCursosProfe(@PathVariable("courseId") Integer id);

    @GetMapping("coursesbyalumn/{courseId}")
    ResponseDTO<List<CourseDTO>> cursosStudent(@PathVariable("courseId") Integer id);

    @GetMapping("coursesNoId/{userId}")
    ResponseDTO<List<CourseDTO>> cursosNoId(@PathVariable("userId") Integer id);

    @GetMapping("/recommended")
    ResponseDTO<List<CourseDTO>> recomendados();

    @GetMapping ("/estudiante/{IdCourse}/{IdAlumno}")
    ResponseDTO<CourseDTO> asignarestudiante(@PathVariable("IdCourse") Integer idCourse, @PathVariable("IdAlumno") Integer idAlumno);

    @GetMapping ("/profesor/{IdCourse}/{IdProfe}")
    ResponseDTO<CourseDTO> asignarprofesor(@PathVariable("IdCourse") Integer idCourse, @PathVariable("IdProfe") Integer IdProfe);
}
