package com.example.resapi.courses.infrastructure.controller_inputPort;

import com.example.resapi.courses.application.dto.FileDTO;
import com.example.resapi.shared.valueObject.ResponseDTO;
import org.springframework.web.bind.annotation.*;

import java.util.List;

public interface FileInputPort {

    @GetMapping("/get/{fileId}")
    ResponseDTO<FileDTO> getFileById(@PathVariable("fileId") Integer fileId);

    @GetMapping("/getAll")
    ResponseDTO<List<FileDTO>> getAll();

    @PostMapping("/create")
    ResponseDTO<FileDTO> createFile (@RequestBody FileDTO file);

    @DeleteMapping("/delete/{fileId}")
    ResponseDTO<FileDTO> deleteFile(@PathVariable("fileId") Integer fileId);
}
