package com.example.resapi.courses.infrastructure.entity;

import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;
import lombok.*;

import java.util.List;

@Entity
@Data
@Getter
@AllArgsConstructor
@NoArgsConstructor
@Builder
public class CourseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    @NotNull
    @Column(unique = true)
    private String name;
    private Float price;
    @ManyToMany(fetch = FetchType.EAGER)
    @JoinTable(name = "course_categories", joinColumns = @JoinColumn(name = "course_id"),
            inverseJoinColumns = @JoinColumn(name = "categories_entity_id"))
    private List<CategoriesEntity> list_Categories; //TODO
    @Column(columnDefinition="JSON")
    private String list_id_professors;
    @Column(columnDefinition="JSON")
    private String list_id_students;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "course")
    private List<PublicationEntity> publications;

    @Override
    public String toString() {
        return "CourseEntity [id=" + id + ", name=" + name + ", price=" + price + ", list_Categories="+ list_Categories + ", list_id_professors="+list_id_professors+", list_id_students="+list_id_students+
                ", publications="+publications.toString() +"]";
    }
}
