package com.example.resapi.courses.infrastructure.entity;

import jakarta.persistence.*;
import lombok.*;

import java.util.List;

@Entity
@Data
@Getter
@AllArgsConstructor
@NoArgsConstructor
@Builder
public class PublicationEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    private String title;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "publication")
    private List<FileEntity> file;
    private String description;
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "course_entity_id", nullable = false, updatable = false)
    private CourseEntity course;

    @Override
    public String toString() {
        return "PublicationEntity [id=" + id + ", title=" + title + ", description=" + description + "]";
    }
}
