package com.example.resapi.courses.infrastructure.mapper;


import com.example.resapi.courses.application.dto.CategoriesDTO;
import com.example.resapi.courses.infrastructure.entity.CategoriesEntity;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class CategoriesMapper implements Serializable {
    private static CategoriesMapper instance;

    private CategoriesMapper(){}

    public static CategoriesMapper getInstance(){
        if(instance==null){
            instance = new CategoriesMapper();
        }
        return instance;
    }

    public CategoriesDTO entityToDto(CategoriesEntity categoriesEntity){
        if(categoriesEntity == null){
            return null;
        }
        return CategoriesDTO.builder()
                .id(categoriesEntity.getId())
                .name(categoriesEntity.getName())
                .build();
    }

    public CategoriesEntity dtoToEntity(CategoriesDTO categoriesDTO){
        if(categoriesDTO ==null){
            return null;
        }
        return CategoriesEntity.builder()
                .id(categoriesDTO.getId())
                .name(categoriesDTO.getName())
                .build();
    }

    public List<CategoriesEntity> listDtoToEntityList(List<CategoriesDTO> categoriesDTOList){
        if(categoriesDTOList==null){
            return Collections.emptyList();
        }
        return categoriesDTOList.stream().map(this::dtoToEntity).collect(Collectors.toList());
    }

    public List<CategoriesDTO> listEntityToDtoList(List<CategoriesEntity> categoriesEntityList){
        if(categoriesEntityList==null){
            return Collections.emptyList();
        }
        return categoriesEntityList.stream().map(this::entityToDto).collect(Collectors.toList());
    }


}
