package com.example.resapi.courses.infrastructure.mapper;


import com.example.resapi.courses.application.dto.ChatMessageDTO;
import com.example.resapi.courses.infrastructure.entity.ChatMessageEntity;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class ChatMessageMapper implements Serializable {
    private static ChatMessageMapper instance;

    private ChatMessageMapper(){}

    public static ChatMessageMapper getInstance(){
        if(instance==null){
            instance = new ChatMessageMapper();
        }
        return instance;
    }

    public ChatMessageDTO entityToDto(ChatMessageEntity chatMessageEntity){
        if(chatMessageEntity == null){
            return null;
        }
        return ChatMessageDTO.builder()
                .id(chatMessageEntity.getId())
                .id_course(chatMessageEntity.getIdCourse())
                .id_account(chatMessageEntity.getId_account())
                .text(chatMessageEntity.getText())
                .time(chatMessageEntity.getTime())
                .build();
    }

    public ChatMessageEntity dtoToEntity(ChatMessageDTO chatMessage){
        if(chatMessage ==null){
            return null;
        }
        return ChatMessageEntity.builder()
                .id(chatMessage.getId())
                .idCourse(chatMessage.getId_course())
                .id_account(chatMessage.getId_account())
                .text(chatMessage.getText())
                .time(chatMessage.getTime())
                .build();
    }

    public List<ChatMessageEntity> listDtoToEntityList(List<ChatMessageDTO> chatMessageDTOList){
        if(chatMessageDTOList==null){
            return Collections.emptyList();
        }
        return chatMessageDTOList.stream().map(this::dtoToEntity).collect(Collectors.toList());
    }

    public List<ChatMessageDTO> listEntityToDtoList(List<ChatMessageEntity> chatMessageEntityList){
        if(chatMessageEntityList==null){
            return Collections.emptyList();
        }
        return chatMessageEntityList.stream().map(this::entityToDto).collect(Collectors.toList());
    }

}
