package com.example.resapi.courses.infrastructure.mapper;

import com.example.resapi.courses.application.dto.FileDTO;
import com.example.resapi.courses.infrastructure.entity.FileEntity;
import com.example.resapi.courses.infrastructure.entity.PublicationEntity;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;
@Service
public class FileMapper implements Serializable {
    private static FileMapper instance;

    private FileMapper(){}

    public static FileMapper getInstance(){
        if(instance==null){
            instance = new FileMapper();
        }
        return instance;
    }

    public FileDTO entityToDto(FileEntity fileEntity){
        if(fileEntity == null){
            return null;
        }
        //PublicationDTO publicationDTO = PublicationMapper.getInstance().entityToDto(fileEntity.getPublication());
        return FileDTO.builder()
                .id(fileEntity.getId())
                .id_account(fileEntity.getId_account())
                //.publicationDTO(publicationDTO)
                .publicationId(fileEntity.getPublication()==null?null:fileEntity.getPublication().getId())
                .path(fileEntity.getPath())
                .url(fileEntity.getUrl())
                .type(fileEntity.getType())
                .build();
    }

    public FileEntity dtoToEntity(FileDTO fileDTO){
        if(fileDTO ==null){
            return null;
        }
        PublicationEntity publicationEntity = PublicationMapper.getInstance().dtoToEntity(fileDTO.getPublicationDTO());
        return FileEntity.builder()
                .id(fileDTO.getId())
                .id_account(fileDTO.getId_account())
                .path(fileDTO.getPath())
                .url(fileDTO.getUrl())
                .type(fileDTO.getType())
                .publication(publicationEntity)
                .build();
    }

    public List<FileEntity> listDtoToEntityList(List<FileDTO> fileDTOList){
        if(fileDTOList==null){
            return Collections.emptyList();
        }
        return fileDTOList.stream().map(this::dtoToEntity).collect(Collectors.toList());
    }

    public List<FileDTO> listEntityToDtoList(List<FileEntity> fileEntityList){
        if(fileEntityList==null){
            return Collections.emptyList();
        }
        return fileEntityList.stream().map(this::entityToDto).collect(Collectors.toList());
    }


}
