package com.example.resapi.courses.infrastructure.repository_outputAdapter.FireBase;

import com.example.resapi.shared.exceptions.TfgException;
import com.example.resapi.shared.valueObject.ResponseDTO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/firebase")
@CrossOrigin
@Slf4j
public class FireBaseController {

    @Autowired
    FireBaseConfig fireBaseConfig;



    @GetMapping("/config")
    public ResponseDTO<FireBaseConfig> getConfig(){
        log.info("...getConfig...");
        System.out.println("fireBaseDTO:"+this.fireBaseConfig);
        ResponseDTO<FireBaseConfig> responseDTO = new ResponseDTO<>();
        try {
            responseDTO.setData(this.fireBaseConfig);
            responseDTO.addInfo("GET_FIREBASE_CONFIG_OK");
        }catch(TfgException e){
            responseDTO.setErrorMessages(e.getErrorMessages());
        }catch (Exception e){
            responseDTO.addError(e.getMessage());
        }
        return responseDTO;
    }

}
