package com.example.resapi.courses.infrastructure.repository_outputAdapter.SQL;

import com.example.resapi.courses.application.dto.CategoriesDTO;
import com.example.resapi.courses.application.repository.CategoriesRepository;
import com.example.resapi.courses.infrastructure.entity.CategoriesEntity;
import com.example.resapi.courses.infrastructure.mapper.CategoriesMapper;
import com.example.resapi.courses.infrastructure.repository_outputPort.SQL.SqlCategoriesRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class SqlCategoriesRepositoryImp  implements CategoriesRepository {

    private final SqlCategoriesRepository categoriesRepository;

    @Autowired
    public SqlCategoriesRepositoryImp(SqlCategoriesRepository sqlCategoriesRepository) {
        this.categoriesRepository = sqlCategoriesRepository;
    }
    @Override
    public CategoriesDTO create(CategoriesDTO categoriesDTO) {
        CategoriesEntity categoriesEntity = CategoriesMapper.getInstance().dtoToEntity(categoriesDTO);
        return CategoriesMapper.getInstance().entityToDto(this.categoriesRepository.save(categoriesEntity));
    }

    @Override
    public CategoriesDTO getById(Integer id) {
        return CategoriesMapper.getInstance().entityToDto(this.categoriesRepository.findById(id).orElse(null));
    }

    @Override
    public CategoriesDTO findByName(String name) {
        return CategoriesMapper.getInstance().entityToDto(this.categoriesRepository.findByName(name));
    }

    @Override
    public CategoriesDTO delete(Integer id) {
        CategoriesDTO categoriesDTO =this.getById(id);
        if (categoriesDTO !=null){
            CategoriesEntity categoriesEntity = CategoriesMapper.getInstance().dtoToEntity(categoriesDTO);
            this.categoriesRepository.delete(categoriesEntity);
        }
        return categoriesDTO;
    }
    @Override
    public CategoriesDTO delete(String name) {
        CategoriesDTO categoriesDTO =findByName(name);
        if (categoriesDTO !=null){
            CategoriesEntity categoriesEntity = CategoriesMapper.getInstance().dtoToEntity(categoriesDTO);
            this.categoriesRepository.delete(categoriesEntity);
        }
        return categoriesDTO;
    }

    @Override
    public List<CategoriesDTO> getAll() {
        List<CategoriesEntity> userEntityList = this.categoriesRepository.findAll();
        return CategoriesMapper.getInstance().listEntityToDtoList(userEntityList);
    }
}
