package com.example.resapi.courses.infrastructure.repository_outputAdapter.SQL;

import com.example.resapi.courses.application.dto.ChatMessageDTO;
import com.example.resapi.courses.application.repository.ChatMessageRepository;
import com.example.resapi.courses.infrastructure.entity.ChatMessageEntity;
import com.example.resapi.courses.infrastructure.mapper.ChatMessageMapper;
import com.example.resapi.courses.infrastructure.repository_outputPort.SQL.SqlChatMessageRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.List;

@Service
public class SqlChatMessageRepositoryImp implements ChatMessageRepository {

    private final SqlChatMessageRepository sqlChatMessageRepository;
    private final ChatMessageMapper chatMessageMapper = ChatMessageMapper.getInstance();
    @Autowired
    public SqlChatMessageRepositoryImp(SqlChatMessageRepository sqlChatMessageRepository) {
        this.sqlChatMessageRepository = sqlChatMessageRepository;
    }

    @Override
    public ChatMessageDTO create(ChatMessageDTO chatMessageDTO) {
        return this.chatMessageMapper.entityToDto(this.sqlChatMessageRepository.save(this.chatMessageMapper.dtoToEntity(chatMessageDTO)));
    }

    @Override
    public ChatMessageDTO getById(Integer id) {
        return this.chatMessageMapper.entityToDto(this.sqlChatMessageRepository.findById(id).orElse(null));
    }
    @Override
    public ChatMessageDTO findByLocalDate(LocalDateTime time) {
        return null;
    }

    @Override
    public ChatMessageDTO update(ChatMessageDTO chatMessageDTO) {
        return null;
    }
    @Override
    public ChatMessageDTO delete(ChatMessageDTO chatMessageDTO) {
        this.sqlChatMessageRepository.delete(this.chatMessageMapper.dtoToEntity(chatMessageDTO));
        return chatMessageDTO;
    }

    @Override
    public List<ChatMessageDTO> getAll() {
        List<ChatMessageEntity> userEntityList = this.sqlChatMessageRepository.findAll();
        return this.chatMessageMapper.listEntityToDtoList(userEntityList);
    }

    @Override
    public List<ChatMessageDTO> findById_Course(Integer courseId) {
        List<ChatMessageEntity> userEntityList = this.sqlChatMessageRepository.findByIdCourse(courseId).orElse(null);
        return this.chatMessageMapper.listEntityToDtoList(userEntityList);
    }
}
