package com.example.resapi.courses.infrastructure.repository_outputAdapter.SQL;

import com.example.resapi.courses.application.dto.CourseDTO;
import com.example.resapi.courses.application.repository.CourseRepository;
import com.example.resapi.courses.infrastructure.entity.CourseEntity;
import com.example.resapi.courses.infrastructure.mapper.CourseMapper;
import com.example.resapi.courses.infrastructure.repository_outputPort.SQL.SqlCourseRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class SqlCourseRepositoryImp implements CourseRepository {

    private final SqlCourseRepository sqlCourseRepository;
    private final CourseMapper courseMapper = CourseMapper.getInstance();

    @Autowired
    public SqlCourseRepositoryImp(SqlCourseRepository sqlCourseRepository) {
        this.sqlCourseRepository = sqlCourseRepository;
    }

    @Override
    public CourseDTO create(CourseDTO course) {
        return courseMapper.entityToDto(this.sqlCourseRepository.save(courseMapper.dtoToEntity(course)));
    }

    @Override
    public CourseDTO getById(Integer id) {
        return this.courseMapper.entityToDto(this.sqlCourseRepository.findById(id).orElse(null));
    }

    @Override
    public CourseDTO findByName(String courseName) {
        return this.courseMapper.entityToDto(this.sqlCourseRepository.findByName(courseName).orElse(null));
    }

    @Override
    public CourseDTO findByNameEntity(String name) {
        return this.courseMapper.entityToDto(this.sqlCourseRepository.findByName(name).orElse(null));
    }
    @Override
    public CourseDTO delete(Integer id) {
        CourseDTO course= this.getById(id);
        if (course!=null)
            this.sqlCourseRepository.delete(courseMapper.dtoToEntity(course));
        return course;
    }

    @Override
    public CourseDTO update(CourseDTO course) {
        return courseMapper.entityToDto(this.sqlCourseRepository.save(courseMapper.dtoToEntity(course)));
    }

    @Override
    public List<CourseDTO> getAll() {
        List<CourseEntity> userEntityList = this.sqlCourseRepository.findAll();
        return this.courseMapper.listEntityToDtoList(userEntityList);
    }

}
