package com.example.resapi.courses.infrastructure.repository_outputAdapter.SQL;

import com.example.resapi.courses.application.dto.FileDTO;
import com.example.resapi.courses.application.repository.FileRepository;
import com.example.resapi.courses.infrastructure.entity.FileEntity;
import com.example.resapi.courses.infrastructure.mapper.FileMapper;
import com.example.resapi.courses.infrastructure.repository_outputPort.SQL.SqlFileRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class SqlFileRepositoryImp implements FileRepository {

    private final SqlFileRepository sqlFileRepository;
    private final FileMapper fileMapper = FileMapper.getInstance();
    @Autowired
    public SqlFileRepositoryImp(SqlFileRepository sqlFileRepository) {
        this.sqlFileRepository = sqlFileRepository;
    }

    @Override
    public FileDTO create(FileDTO file) {
        return fileMapper.entityToDto(sqlFileRepository.save(fileMapper.dtoToEntity(file)));
    }

    @Override
    public FileDTO getById(Integer id) {
        return this.fileMapper.entityToDto(this.sqlFileRepository.findById(id).orElse(null));
    }

    @Override
    public FileDTO findByPath(String filePath) {
        return this.fileMapper.entityToDto(this.sqlFileRepository.findByPath(filePath).orElse(null));
    }
    @Override
    public FileDTO findByUrl(String url) {
        return this.fileMapper.entityToDto(this.sqlFileRepository.findByUrl(url).orElse(null));
    }

    @Override
    public FileDTO update(FileDTO file) {
        System.out.println("Update File Not Allowed");
        return null;
    }
    @Override
    public void delete(FileDTO file) {
        this.sqlFileRepository.delete(fileMapper.dtoToEntity(file));
    }

    @Override
    public List<FileDTO> getAll() {
        List<FileEntity> fileEntityList = this.sqlFileRepository.findAll();
        return this.fileMapper.listEntityToDtoList(fileEntityList);
    }
}
